<?php

namespace Assetdocs\Assetsrequest\Policies;

use App\User;
use Illuminate\Auth\Access\HandlesAuthorization;
use Assetdocs\Assetsrequest\Models\Assetreqhd;

class AssetreqhdPolicy
{
    use HandlesAuthorization;

    /**
     * Determine if the given user can view the assetreqhd.
     *
     * @param User $user
     * @param Assetreqhd $assetreqhd
     *
     * @return bool
     */
    public function view(User $user, Assetreqhd $assetreqhd)
    {
        if ($user->canDo('assetsrequest.assetreqhd.view') && $user->is('admin')) {
            return true;
        }

        return $user->id === $assetreqhd->user_id;
    }

    /**
     * Determine if the given user can create a assetreqhd.
     *
     * @param User $user
     * @param Assetreqhd $assetreqhd
     *
     * @return bool
     */
    public function create(User $user)
    {
        return  $user->canDo('assetsrequest.assetreqhd.create');
    }

    /**
     * Determine if the given user can update the given assetreqhd.
     *
     * @param User $user
     * @param Assetreqhd $assetreqhd
     *
     * @return bool
     */
    public function update(User $user, Assetreqhd $assetreqhd)
    {
        if ($user->canDo('assetsrequest.assetreqhd.update') && $user->is('admin')) {
            return true;
        }

        return $user->id === $assetreqhd->user_id;
    }

    /**
     * Determine if the given user can delete the given assetreqhd.
     *
     * @param User $user
     * @param Assetreqhd $assetreqhd
     *
     * @return bool
     */
    public function destroy(User $user, Assetreqhd $assetreqhd)
    {
        if ($user->canDo('assetsrequest.assetreqhd.delete') && $user->is('admin')) {
            return true;
        }

        return $user->id === $assetreqhd->user_id;
    }

    /**
     * Determine if the user can perform a given action ve.
     *
     * @param [type] $user    [description]
     * @param [type] $ability [description]
     *
     * @return [type] [description]
     */
    public function before($user, $ability)
    {
        if ($user->isSuperUser()) {
            return true;
        }
    }
}
